* vim: ts=3:sw=3
CFunction dcolor(symmetric);

#procedure colorlibrary
* Precomputed rules for certain common combinations of generators
	Id f(idx1C8?,idx3C8?,idx4C8?)*f(idx2C8?,idx4C8?,idx3C8?) =
		- 2*NC*T(idx1C8,iDUMMY1,iDUMMY2)*T(idx2C8,iDUMMY2,iDUMMY1);
	Sum iDUMMY1, iDUMMY2;

* Star-Triangle relation f-f-f
	Id f(idx1C8?,idx4C8?,idx5C8?)*
			f(idx2C8?,idx5C8?,idx6C8?)*
			f(idx3C8?,idx6C8?,idx4C8?) =
		TR * NC * f(idx1C8,idx2C8,idx3C8);
* Star-Triangle relation f-T-T
	Id T(idx1C8?, idx1C3?, idx3C3?) *
			T(idx2C8?, idx3C3?, idx2C3?) *
			f(idx1C8?,idx2C8?,idx3C8?) =
		T(idx3C8,idx1C3,idx2C3)*i_*TR*NC;
* Star-Triangle relation T-T-T
	Id T(idx1C8, idx1C3, idx2C3) *
			T(idx2C8, idx2C3, idx3C3) *
			T(idx1C8,idx3C3,idx4C3) =
		- T(idx2C8,idx1C3,idx4C3)*TR/NC;
#endprocedure

#procedure liealgebra
	Repeat;
		Id f(idx1C8?, idx2C8?, idx3C8)*T(idx3C8?, idx1C3?, idx2C3?) =
	   	- T(idx1C8,idx1C3,iDUMMY1)*T(idx2C8,iDUMMY1,idx2C3)*i_
			+ T(idx1C8,iDUMMY1,idx2C3)*T(idx2C8,idx1C3,iDUMMY1)*i_;
		Sum iDUMMY1;
	EndRepeat;
#endprocedure

#procedure coloralgebra(INPAR)
*   Brackets f4, f;
.sort:coloralgebra first;
*   Keep Brackets;

   #if `INPAR'
	   InParallel;
	#endif
	Repeat;
		Id Once f4(idx1C8?, idx2C8?, idx3C8?, idx4C8?) =
			f(idx1C8, idx2C8, iDUMMY1) *
			f(idx3C8, idx4C8, iDUMMY1);

		Sum iDUMMY1;
	EndRepeat;

	#call colorlibrary
	#call liealgebra

	Repeat;
		Id Once f(idx1C8?, idx2C8?, idx3C8?) = - i_ / TR * 
			(
				+ T(idx1C8, iDUMMY1, iDUMMY2) *
				  T(idx2C8, iDUMMY2, iDUMMY3) *
				  T(idx3C8, iDUMMY3, iDUMMY1)
				- T(idx3C8, iDUMMY1, iDUMMY2) *
				  T(idx2C8, iDUMMY2, iDUMMY3) *
				  T(idx1C8, iDUMMY3, iDUMMY1)
			);
		Sum iDUMMY1, iDUMMY2, iDUMMY3;

		#call liealgebra
	EndRepeat;

	Repeat;
		Id T(idx0C8?, idx1C3?, idx1C3?) = 0;

		Id dcolor(idx1C3? idx0C3?) * dcolor(idx0C3?, idx2C3?) =
			dcolor(idx1C3, idx2C3);

		Id dcolor(idx1C3?, idx0C3?) * T(idx3C8?, idx0C3?, idx2C3?) =
			T(idx3C8, idx1C3, idx2C3);
		Also T(idx3C8?, idx1C3?, idx0C3?) * dcolor(idx0C3?, idx2C3?) =
			T(idx3C8, idx1C3, idx2C3);
		Also dcolor(idx1C3?, idx1C3?) = NC;

		Id T(idx0C8?, idx1C3?, idx2C3?) * T(idx0C8?, idx3C3?, idx4C3?) =
			TR * (
				+ dcolor(idx1C3, idx4C3) * dcolor(idx2C3, idx3C3)
				- 1/NC * dcolor(idx1C3, idx2C3) * dcolor(idx3C3, idx4C3)
			);
	EndRepeat;

	Id dcolor(idx1C3?, idx2C3?) = d_(idx1C3, idx2C3);

*   Brackets inpcolor, outcolor, T, delta, dcolor;
.sort:coloralgebra last;
*   Keep Brackets;
	#call colorbasis
#endprocedure
