module     P5B_uux_ddx_d29h0l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P5B_uux_
   ! ddx/helicity0/d29h0l1.f90
   ! generator: haggies (1.1)
   use P5B_uux_ddx_config, only: ki
   use P5B_uux_ddx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P5B_uux_ddx_groups, only: &
!           & sign => diagram29_sign, shift => diagram29_shift
      use P5B_uux_ddx_globalsl1, only: epspow
      use P5B_uux_ddx_kinematics
      use P5B_uux_ddx_abbrevd29h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d29
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d29 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t3 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4))
      t4 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t5 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t6 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t7 = t1*abb29n12
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t10 = t1*abb29n13
      t11 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t12 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t13 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t14 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t15 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t16 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4)&
      &)
      t17 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4)&
      &)
      t18 = (Q(1)*spvak6k3(1)-Q(2)*spvak6k3(2)-Q(3)*spvak6k3(3)-Q(4)*spvak6k3(4)&
      &)
      t19 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t20 = (Q(1)*spvak8k3(1)-Q(2)*spvak8k3(2)-Q(3)*spvak8k3(3)-Q(4)*spvak8k3(4)&
      &)
      t21 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t22 = (Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)*spvak4k5(4)&
      &)
      t23 = (Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6(4)&
      &)
      t24 = (Q(1)*spvak4k7(1)-Q(2)*spvak4k7(2)-Q(3)*spvak4k7(3)-Q(4)*spvak4k7(4)&
      &)
      t25 = (Q(1)*spvak4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4)&
      &)
      d29 = (t1*abb29n11+t1*abb29n51+t1*abb29n8+t10*t11+t10*t9+t2*abb29n26+t3*ab&
      &b29n31+t3*abb29n9+t4*abb29n32+t6*t7+t7*t8+t1*t13*abb29n15+t1*t15*abb29n16&
      &+t1*t18*abb29n37+t1*t19*abb29n40+t1*t20*abb29n42+t1*t21*abb29n43+t1*t22*a&
      &bb29n46+t1*t23*abb29n48+t1*t24*abb29n49+t1*t25*abb29n52+t1*t3*abb29n19+t1&
      &*t5*abb29n20+t11*t16*abb29n27+t11*t17*abb29n33+t12*t13*abb29n14+t12*t15*a&
      &bb29n17+t12*t18*abb29n38+t12*t19*abb29n39+t12*t20*abb29n41+t12*t21*abb29n&
      &44+t12*t22*abb29n45+t12*t23*abb29n47+t12*t24*abb29n50+t12*t25*abb29n53+t1&
      &2*t3*abb29n18+t12*t5*abb29n21+t13*t14*abb29n14+t13*t16*abb29n29+t13*t17*a&
      &bb29n35+t14*t15*abb29n17+t14*t18*abb29n38+t14*t19*abb29n39+t14*t20*abb29n&
      &41+t14*t21*abb29n44+t14*t22*abb29n45+t14*t23*abb29n47+t14*t24*abb29n50+t1&
      &4*t25*abb29n53+t14*t3*abb29n18+t14*t5*abb29n21+t15*t16*abb29n30+t15*t17*a&
      &bb29n36+t16*t6*abb29n28+t16*t8*abb29n28+t16*t9*abb29n27+t17*t6*abb29n34+t&
      &17*t8*abb29n34+t17*t9*abb29n33+t18*t5*abb29n58+t19*t5*abb29n59+t2*t5*abb2&
      &9n62+t20*t5*abb29n60+t21*t5*abb29n61+t22*t5*abb29n54+t23*t5*abb29n55+t24*&
      &t5*abb29n56+t25*t5*abb29n57+t3*t5*abb29n10+t3*t5*abb29n64+t4*t5*abb29n63+&
      &t11*t3*t5*abb29n22+t13*t3*t5*abb29n24+t15*t3*t5*abb29n25+t3*t5*t6*abb29n2&
      &3+t3*t5*t8*abb29n23+t3*t5*t9*abb29n22)
      numerator = cmplx(real(d29, ki), aimag(d29), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P5B_uux_ddx_globalsl1, only: epspow
      use P5B_uux_ddx_kinematics
      use P5B_uux_ddx_abbrevd29h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d29
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d29 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t3 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4))
      t4 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t5 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t6 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t7 = t1*abb29n12
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t10 = t1*abb29n13
      t11 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t12 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t13 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t14 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t15 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t16 = (Q(1)*spvak4k2(1)-Q(2)*spvak4k2(2)-Q(3)*spvak4k2(3)-Q(4)*spvak4k2(4)&
      &)
      t17 = (Q(1)*spvak1k3(1)-Q(2)*spvak1k3(2)-Q(3)*spvak1k3(3)-Q(4)*spvak1k3(4)&
      &)
      t18 = (Q(1)*spvak6k3(1)-Q(2)*spvak6k3(2)-Q(3)*spvak6k3(3)-Q(4)*spvak6k3(4)&
      &)
      t19 = (Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4)&
      &)
      t20 = (Q(1)*spvak8k3(1)-Q(2)*spvak8k3(2)-Q(3)*spvak8k3(3)-Q(4)*spvak8k3(4)&
      &)
      t21 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t22 = (Q(1)*spvak4k5(1)-Q(2)*spvak4k5(2)-Q(3)*spvak4k5(3)-Q(4)*spvak4k5(4)&
      &)
      t23 = (Q(1)*spvak4k6(1)-Q(2)*spvak4k6(2)-Q(3)*spvak4k6(3)-Q(4)*spvak4k6(4)&
      &)
      t24 = (Q(1)*spvak4k7(1)-Q(2)*spvak4k7(2)-Q(3)*spvak4k7(3)-Q(4)*spvak4k7(4)&
      &)
      t25 = (Q(1)*spvak4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4)&
      &)
      d29 = (t1*abb29n11+t1*abb29n51+t1*abb29n8+t10*t11+t10*t9+t2*abb29n26+t3*ab&
      &b29n31+t3*abb29n9+t4*abb29n32+t6*t7+t7*t8+t1*t13*abb29n15+t1*t15*abb29n16&
      &+t1*t18*abb29n37+t1*t19*abb29n40+t1*t20*abb29n42+t1*t21*abb29n43+t1*t22*a&
      &bb29n46+t1*t23*abb29n48+t1*t24*abb29n49+t1*t25*abb29n52+t1*t3*abb29n19+t1&
      &*t5*abb29n20+t11*t16*abb29n27+t11*t17*abb29n33+t12*t13*abb29n14+t12*t15*a&
      &bb29n17+t12*t18*abb29n38+t12*t19*abb29n39+t12*t20*abb29n41+t12*t21*abb29n&
      &44+t12*t22*abb29n45+t12*t23*abb29n47+t12*t24*abb29n50+t12*t25*abb29n53+t1&
      &2*t3*abb29n18+t12*t5*abb29n21+t13*t14*abb29n14+t13*t16*abb29n29+t13*t17*a&
      &bb29n35+t14*t15*abb29n17+t14*t18*abb29n38+t14*t19*abb29n39+t14*t20*abb29n&
      &41+t14*t21*abb29n44+t14*t22*abb29n45+t14*t23*abb29n47+t14*t24*abb29n50+t1&
      &4*t25*abb29n53+t14*t3*abb29n18+t14*t5*abb29n21+t15*t16*abb29n30+t15*t17*a&
      &bb29n36+t16*t6*abb29n28+t16*t8*abb29n28+t16*t9*abb29n27+t17*t6*abb29n34+t&
      &17*t8*abb29n34+t17*t9*abb29n33+t18*t5*abb29n58+t19*t5*abb29n59+t2*t5*abb2&
      &9n62+t20*t5*abb29n60+t21*t5*abb29n61+t22*t5*abb29n54+t23*t5*abb29n55+t24*&
      &t5*abb29n56+t25*t5*abb29n57+t3*t5*abb29n10+t3*t5*abb29n64+t4*t5*abb29n63+&
      &t11*t3*t5*abb29n22+t13*t3*t5*abb29n24+t15*t3*t5*abb29n25+t3*t5*t6*abb29n2&
      &3+t3*t5*t8*abb29n23+t3*t5*t9*abb29n22)

      numerator = cmplx(real(d29, ki), aimag(d29), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P5B_uux_ddx_d29h0l1
