module     P5B_uux_ddx_d6h0l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P5B_uux_
   ! ddx/helicity0/d6h0l1.f90
   ! generator: haggies (1.1)
   use P5B_uux_ddx_config, only: ki
   use P5B_uux_ddx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P5B_uux_ddx_groups, only: &
!           & sign => diagram6_sign, shift => diagram6_shift
      use P5B_uux_ddx_globalsl1, only: epspow
      use P5B_uux_ddx_kinematics
      use P5B_uux_ddx_abbrevd6h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d6
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d6 = 0.0_ki
      t1 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t4 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t5 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t6 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t7 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t8 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t9 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t10 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t11 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t12 = t2*abb6n26
      t13 = t2*abb6n28
      t14 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4)&
      &)
      t15 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t16 = (Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)*spvak5k8(4)&
      &)
      t17 = (Q(1)*spvak7k6(1)-Q(2)*spvak7k6(2)-Q(3)*spvak7k6(3)-Q(4)*spvak7k6(4)&
      &)
      d6 = (t1*abb6n11+t10*abb6n7+t11*abb6n8+t12*t6+t12*t7+t13*t4+t13*t5+t2*abb6&
      &n18+t2*t2*abb6n27+t3*abb6n23+t4*abb6n4+t5*abb6n4+t6*abb6n5+t7*abb6n5+t8*a&
      &bb6n6+t9*abb6n7+t1*t11*abb6n15+t1*t14*abb6n48+t1*t2*abb6n13+t1*t3*abb6n24&
      &+t1*t4*abb6n14+t1*t5*abb6n14+t1*t6*abb6n12+t1*t7*abb6n12+t1*t8*abb6n29+t1&
      &0*t11*abb6n10+t10*t14*abb6n44+t10*t3*abb6n3+t11*t2*abb6n22+t11*t8*abb6n9+&
      &t11*t9*abb6n10+t14*t15*abb6n35+t14*t2*abb6n43+t14*t3*abb6n34+t14*t4*abb6n&
      &33+t14*t5*abb6n33+t14*t6*abb6n32+t14*t7*abb6n32+t14*t8*abb6n36+t14*t9*abb&
      &6n44+t2*t3*abb6n19+t2*t8*abb6n20+t3*t8*abb6n2+t3*t9*abb6n3+t1*t10*t14*abb&
      &6n51+t1*t11*t8*abb6n16+t1*t14*t15*abb6n38+t1*t14*t17*abb6n54+t1*t14*t2*ab&
      &b6n52+t1*t14*t3*abb6n55+t1*t14*t4*abb6n50+t1*t14*t5*abb6n50+t1*t14*t6*abb&
      &6n53+t1*t14*t7*abb6n53+t1*t14*t8*abb6n31+t1*t14*t9*abb6n51+t1*t14*abb6n49&
      &*(Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4))+t1&
      &*t2*t8*abb6n30+t10*t14*t16*abb6n41+t10*t14*t17*abb6n46+t10*t14*t3*abb6n40&
      &+t10*t14*t8*abb6n47+t14*t15*t8*abb6n37+t14*t16*t2*abb6n42+t14*t16*t9*abb6&
      &n41+t14*t17*t2*abb6n45+t14*t17*t9*abb6n46+t14*t2*t3*abb6n39+t14*t3*t9*abb&
      &6n40+t14*t8*t9*abb6n47+t15*t2*t8*abb6n21+t2*t3*t8*abb6n17+t2*t8*abb6n25*(&
      &Q(1)*spvak4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4))+t1*t&
      &14*t3*t8*abb6n56)
      numerator = cmplx(real(d6, ki), aimag(d6), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P5B_uux_ddx_globalsl1, only: epspow
      use P5B_uux_ddx_kinematics
      use P5B_uux_ddx_abbrevd6h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d6
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d6 = 0.0_ki
      t1 = (Q(1)*spvak4k3(1)-Q(2)*spvak4k3(2)-Q(3)*spvak4k3(3)-Q(4)*spvak4k3(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t4 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t5 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t6 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t7 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t8 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t9 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t10 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t11 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t12 = t2*abb6n26
      t13 = t2*abb6n28
      t14 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4)&
      &)
      t15 = (Q(1)*spvak7k3(1)-Q(2)*spvak7k3(2)-Q(3)*spvak7k3(3)-Q(4)*spvak7k3(4)&
      &)
      t16 = (Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)*spvak5k8(4)&
      &)
      t17 = (Q(1)*spvak7k6(1)-Q(2)*spvak7k6(2)-Q(3)*spvak7k6(3)-Q(4)*spvak7k6(4)&
      &)
      d6 = (t1*abb6n11+t10*abb6n7+t11*abb6n8+t12*t6+t12*t7+t13*t4+t13*t5+t2*abb6&
      &n18+t2*t2*abb6n27+t3*abb6n23+t4*abb6n4+t5*abb6n4+t6*abb6n5+t7*abb6n5+t8*a&
      &bb6n6+t9*abb6n7+t1*t11*abb6n15+t1*t14*abb6n48+t1*t2*abb6n13+t1*t3*abb6n24&
      &+t1*t4*abb6n14+t1*t5*abb6n14+t1*t6*abb6n12+t1*t7*abb6n12+t1*t8*abb6n29+t1&
      &0*t11*abb6n10+t10*t14*abb6n44+t10*t3*abb6n3+t11*t2*abb6n22+t11*t8*abb6n9+&
      &t11*t9*abb6n10+t14*t15*abb6n35+t14*t2*abb6n43+t14*t3*abb6n34+t14*t4*abb6n&
      &33+t14*t5*abb6n33+t14*t6*abb6n32+t14*t7*abb6n32+t14*t8*abb6n36+t14*t9*abb&
      &6n44+t2*t3*abb6n19+t2*t8*abb6n20+t3*t8*abb6n2+t3*t9*abb6n3+t1*t10*t14*abb&
      &6n51+t1*t11*t8*abb6n16+t1*t14*t15*abb6n38+t1*t14*t17*abb6n54+t1*t14*t2*ab&
      &b6n52+t1*t14*t3*abb6n55+t1*t14*t4*abb6n50+t1*t14*t5*abb6n50+t1*t14*t6*abb&
      &6n53+t1*t14*t7*abb6n53+t1*t14*t8*abb6n31+t1*t14*t9*abb6n51+t1*t14*abb6n49&
      &*(Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4))+t1&
      &*t2*t8*abb6n30+t10*t14*t16*abb6n41+t10*t14*t17*abb6n46+t10*t14*t3*abb6n40&
      &+t10*t14*t8*abb6n47+t14*t15*t8*abb6n37+t14*t16*t2*abb6n42+t14*t16*t9*abb6&
      &n41+t14*t17*t2*abb6n45+t14*t17*t9*abb6n46+t14*t2*t3*abb6n39+t14*t3*t9*abb&
      &6n40+t14*t8*t9*abb6n47+t15*t2*t8*abb6n21+t2*t3*t8*abb6n17+t2*t8*abb6n25*(&
      &Q(1)*spvak4k8(1)-Q(2)*spvak4k8(2)-Q(3)*spvak4k8(3)-Q(4)*spvak4k8(4))+t1*t&
      &14*t3*t8*abb6n56)

      numerator = cmplx(real(d6, ki), aimag(d6), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P5B_uux_ddx_d6h0l1
