module     P5B_uux_ddx_d1h1l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P5B_uux_
   ! ddx/helicity1/d1h1l1.f90
   ! generator: haggies (1.1)
   use P5B_uux_ddx_config, only: ki
   use P5B_uux_ddx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P5B_uux_ddx_groups, only: &
!           & sign => diagram1_sign, shift => diagram1_shift
      use P5B_uux_ddx_globalsl1, only: epspow
      use P5B_uux_ddx_kinematics
      use P5B_uux_ddx_abbrevd1h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d1
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d1 = 0.0_ki
      t1 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t4 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t5 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t6 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t7 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t8 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t9 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t10 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t11 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t12 = t2*abb1n27
      t13 = t2*abb1n29
      t14 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4)&
      &)
      t15 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t16 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t17 = (Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4)&
      &)
      d1 = (t1*abb1n10+t10*abb1n6+t11*abb1n7+t12*t5+t12*t6+t13*t7+t13*t8+t2*abb1&
      &n18+t2*t2*abb1n28+t3*abb1n26+t4*abb1n3+t5*abb1n4+t6*abb1n4+t7*abb1n5+t8*a&
      &bb1n5+t9*abb1n6+t1*t10*abb1n11+t1*t11*abb1n16+t1*t2*abb1n22+t1*t4*abb1n9+&
      &t1*t9*abb1n11+t10*t14*abb1n41+t10*t3*abb1n8+t11*t14*abb1n46+t11*t2*abb1n1&
      &3+t11*t3*abb1n30+t11*t4*abb1n24+t11*t5*abb1n12+t11*t6*abb1n12+t11*t7*abb1&
      &n14+t11*t8*abb1n14+t14*t15*abb1n37+t14*t2*abb1n42+t14*t3*abb1n35+t14*t4*a&
      &bb1n32+t14*t5*abb1n34+t14*t6*abb1n34+t14*t7*abb1n33+t14*t8*abb1n33+t14*t9&
      &*abb1n41+t2*t3*abb1n21+t2*t4*abb1n19+t3*t4*abb1n2+t3*t9*abb1n8+t1*t11*t4*&
      &abb1n15+t10*t11*t14*abb1n52+t10*t14*t16*abb1n39+t10*t14*t17*abb1n48+t10*t&
      &14*t3*abb1n44+t10*t14*t4*abb1n38+t11*t14*t15*abb1n49+t11*t14*t2*abb1n53+t&
      &11*t14*t3*abb1n55+t11*t14*t4*abb1n31+t11*t14*t5*abb1n51+t11*t14*t6*abb1n5&
      &1+t11*t14*t7*abb1n54+t11*t14*t8*abb1n54+t11*t14*t9*abb1n52+t11*t14*abb1n4&
      &5*(Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4))+t&
      &11*t14*abb1n50*(Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)*s&
      &pvak5k8(4))+t11*t2*t4*abb1n25+t14*t15*t4*abb1n36+t14*t16*t2*abb1n40+t14*t&
      &16*t9*abb1n39+t14*t17*t2*abb1n47+t14*t17*t9*abb1n48+t14*t2*t3*abb1n43+t14&
      &*t3*t9*abb1n44+t14*t4*t9*abb1n38+t15*t2*t4*abb1n20+t2*t3*t4*abb1n17+t2*t4&
      &*abb1n23*(Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k&
      &6(4))+t11*t14*t3*t4*abb1n56)
      numerator = cmplx(real(d1, ki), aimag(d1), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P5B_uux_ddx_globalsl1, only: epspow
      use P5B_uux_ddx_kinematics
      use P5B_uux_ddx_abbrevd1h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d1
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d1 = 0.0_ki
      t1 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t4 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t5 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t6 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t7 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t8 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t9 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t10 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t11 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t12 = t2*abb1n27
      t13 = t2*abb1n29
      t14 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4)&
      &)
      t15 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t16 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t17 = (Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4)&
      &)
      d1 = (t1*abb1n10+t10*abb1n6+t11*abb1n7+t12*t5+t12*t6+t13*t7+t13*t8+t2*abb1&
      &n18+t2*t2*abb1n28+t3*abb1n26+t4*abb1n3+t5*abb1n4+t6*abb1n4+t7*abb1n5+t8*a&
      &bb1n5+t9*abb1n6+t1*t10*abb1n11+t1*t11*abb1n16+t1*t2*abb1n22+t1*t4*abb1n9+&
      &t1*t9*abb1n11+t10*t14*abb1n41+t10*t3*abb1n8+t11*t14*abb1n46+t11*t2*abb1n1&
      &3+t11*t3*abb1n30+t11*t4*abb1n24+t11*t5*abb1n12+t11*t6*abb1n12+t11*t7*abb1&
      &n14+t11*t8*abb1n14+t14*t15*abb1n37+t14*t2*abb1n42+t14*t3*abb1n35+t14*t4*a&
      &bb1n32+t14*t5*abb1n34+t14*t6*abb1n34+t14*t7*abb1n33+t14*t8*abb1n33+t14*t9&
      &*abb1n41+t2*t3*abb1n21+t2*t4*abb1n19+t3*t4*abb1n2+t3*t9*abb1n8+t1*t11*t4*&
      &abb1n15+t10*t11*t14*abb1n52+t10*t14*t16*abb1n39+t10*t14*t17*abb1n48+t10*t&
      &14*t3*abb1n44+t10*t14*t4*abb1n38+t11*t14*t15*abb1n49+t11*t14*t2*abb1n53+t&
      &11*t14*t3*abb1n55+t11*t14*t4*abb1n31+t11*t14*t5*abb1n51+t11*t14*t6*abb1n5&
      &1+t11*t14*t7*abb1n54+t11*t14*t8*abb1n54+t11*t14*t9*abb1n52+t11*t14*abb1n4&
      &5*(Q(1)*spvak5k3(1)-Q(2)*spvak5k3(2)-Q(3)*spvak5k3(3)-Q(4)*spvak5k3(4))+t&
      &11*t14*abb1n50*(Q(1)*spvak5k8(1)-Q(2)*spvak5k8(2)-Q(3)*spvak5k8(3)-Q(4)*s&
      &pvak5k8(4))+t11*t2*t4*abb1n25+t14*t15*t4*abb1n36+t14*t16*t2*abb1n40+t14*t&
      &16*t9*abb1n39+t14*t17*t2*abb1n47+t14*t17*t9*abb1n48+t14*t2*t3*abb1n43+t14&
      &*t3*t9*abb1n44+t14*t4*t9*abb1n38+t15*t2*t4*abb1n20+t2*t3*t4*abb1n17+t2*t4&
      &*abb1n23*(Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k&
      &6(4))+t11*t14*t3*t4*abb1n56)

      numerator = cmplx(real(d1, ki), aimag(d1), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P5B_uux_ddx_d1h1l1
