module     P5B_uux_ddx_d5h1l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P5B_uux_
   ! ddx/helicity1/d5h1l1.f90
   ! generator: haggies (1.1)
   use P5B_uux_ddx_config, only: ki
   use P5B_uux_ddx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P5B_uux_ddx_groups, only: &
!           & sign => diagram5_sign, shift => diagram5_shift
      use P5B_uux_ddx_globalsl1, only: epspow
      use P5B_uux_ddx_kinematics
      use P5B_uux_ddx_abbrevd5h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d5
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d5 = 0.0_ki
      t1 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t4 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t5 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t6 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t7 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t8 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t9 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4))
      t10 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t11 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4)&
      &)
      t12 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4)&
      &)
      t13 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t14 = t4*abb5n33
      t15 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t16 = (Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4)&
      &)
      d5 = (t1*abb5n20+t14*t2+t14*t3+t2*abb5n23+t3*abb5n23+t4*abb5n24+t4*t4*abb5&
      &n34+t5*abb5n38+t6*abb5n5+t7*abb5n5+t8*abb5n6+t9*abb5n7+t1*t10*abb5n21+t1*&
      &t4*abb5n16+t1*t5*abb5n46+t1*t8*abb5n3+t1*t9*abb5n4+t10*t12*abb5n2+t10*t13&
      &*abb5n9+t10*t2*abb5n31+t10*t3*abb5n31+t10*t4*abb5n32+t10*t5*abb5n40+t10*t&
      &6*abb5n10+t11*t4*abb5n11+t12*t4*abb5n12+t13*t4*abb5n15+t2*t5*abb5n45+t2*t&
      &8*abb5n26+t2*t9*abb5n27+t3*t5*abb5n45+t3*t8*abb5n26+t3*t9*abb5n27+t4*t5*a&
      &bb5n44+t4*t6*abb5n17+t4*t8*abb5n25+t4*t9*abb5n28+t5*t6*abb5n43+t5*t7*abb5&
      &n43+t5*t8*abb5n48+t5*t9*abb5n49+t1*t10*t5*abb5n54+t1*t11*t8*abb5n8+t1*t2*&
      &t8*abb5n14+t1*t3*t8*abb5n14+t1*t4*t5*abb5n50+t1*t4*t8*abb5n13+t1*t5*t9*ab&
      &b5n47+t10*t12*t5*abb5n22+t10*t13*t5*abb5n39+t10*t2*t8*abb5n36+t10*t3*t8*a&
      &bb5n36+t10*t4*t5*abb5n56+t10*t4*t8*abb5n35+t10*t5*t6*abb5n55+t10*t5*t8*ab&
      &b5n41+t11*t5*t8*abb5n42+t15*t2*t8*abb5n18+t15*t3*t8*abb5n18+t15*t4*t8*abb&
      &5n19+t16*t2*t8*abb5n30+t16*t3*t8*abb5n30+t16*t4*t8*abb5n29+t2*t5*t8*abb5n&
      &51+t3*t5*t8*abb5n51+t4*t5*t9*abb5n52+t4*t5*abb5n53*(Q(1)*spvak3k6(1)-Q(2)&
      &*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))+t5*t8*abb5n37*(Q(1)*spvak&
      &3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))+t1*t10*t5*t8*a&
      &bb5n57)
      numerator = cmplx(real(d5, ki), aimag(d5), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P5B_uux_ddx_globalsl1, only: epspow
      use P5B_uux_ddx_kinematics
      use P5B_uux_ddx_abbrevd5h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d5
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d5 = 0.0_ki
      t1 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t4 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t5 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t6 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t7 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t8 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t9 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4))
      t10 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t11 = (Q(1)*spvak3k2(1)-Q(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4)&
      &)
      t12 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4)&
      &)
      t13 = (Q(1)*spvak7k2(1)-Q(2)*spvak7k2(2)-Q(3)*spvak7k2(3)-Q(4)*spvak7k2(4)&
      &)
      t14 = t4*abb5n33
      t15 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t16 = (Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4)&
      &)
      d5 = (t1*abb5n20+t14*t2+t14*t3+t2*abb5n23+t3*abb5n23+t4*abb5n24+t4*t4*abb5&
      &n34+t5*abb5n38+t6*abb5n5+t7*abb5n5+t8*abb5n6+t9*abb5n7+t1*t10*abb5n21+t1*&
      &t4*abb5n16+t1*t5*abb5n46+t1*t8*abb5n3+t1*t9*abb5n4+t10*t12*abb5n2+t10*t13&
      &*abb5n9+t10*t2*abb5n31+t10*t3*abb5n31+t10*t4*abb5n32+t10*t5*abb5n40+t10*t&
      &6*abb5n10+t11*t4*abb5n11+t12*t4*abb5n12+t13*t4*abb5n15+t2*t5*abb5n45+t2*t&
      &8*abb5n26+t2*t9*abb5n27+t3*t5*abb5n45+t3*t8*abb5n26+t3*t9*abb5n27+t4*t5*a&
      &bb5n44+t4*t6*abb5n17+t4*t8*abb5n25+t4*t9*abb5n28+t5*t6*abb5n43+t5*t7*abb5&
      &n43+t5*t8*abb5n48+t5*t9*abb5n49+t1*t10*t5*abb5n54+t1*t11*t8*abb5n8+t1*t2*&
      &t8*abb5n14+t1*t3*t8*abb5n14+t1*t4*t5*abb5n50+t1*t4*t8*abb5n13+t1*t5*t9*ab&
      &b5n47+t10*t12*t5*abb5n22+t10*t13*t5*abb5n39+t10*t2*t8*abb5n36+t10*t3*t8*a&
      &bb5n36+t10*t4*t5*abb5n56+t10*t4*t8*abb5n35+t10*t5*t6*abb5n55+t10*t5*t8*ab&
      &b5n41+t11*t5*t8*abb5n42+t15*t2*t8*abb5n18+t15*t3*t8*abb5n18+t15*t4*t8*abb&
      &5n19+t16*t2*t8*abb5n30+t16*t3*t8*abb5n30+t16*t4*t8*abb5n29+t2*t5*t8*abb5n&
      &51+t3*t5*t8*abb5n51+t4*t5*t9*abb5n52+t4*t5*abb5n53*(Q(1)*spvak3k6(1)-Q(2)&
      &*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))+t5*t8*abb5n37*(Q(1)*spvak&
      &3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))+t1*t10*t5*t8*a&
      &bb5n57)

      numerator = cmplx(real(d5, ki), aimag(d5), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P5B_uux_ddx_d5h1l1
