module     P5B_uux_ddx_samuraih1
   ! This file has been generated for samurai version 2.0
   use precision, only: ki_sam => ki
   use P5B_uux_ddx_config, only: ki
   use P5B_uux_ddx_scalar_cache
   implicit none
   private
   public :: reduce_group0
   public :: reduce_group1
   public :: reduce_group2
contains
!---#[ grouped numerators for samurai:
!-----#[ function numeval_group0:
function     numeval_group0(icut, Q, mu2) result(num)
   use P5B_uux_ddx_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P5B_uux_ddx_model
   use P5B_uux_ddx_d9h1l1, only: numerator_d9 => numerator_samurai
   use P5B_uux_ddx_d10h1l1, only: numerator_d10 => numerator_samurai
   use P5B_uux_ddx_d11h1l1, only: numerator_d11 => numerator_samurai
   use P5B_uux_ddx_d12h1l1, only: numerator_d12 => numerator_samurai
   implicit none
   integer, intent(in) :: icut
   complex(ki_sam), dimension(4), intent(in) :: Q
   real(ki_sam), intent(in) :: mu2
   complex(ki_sam) :: num

   logical, dimension(0:4-1) :: nonzero
   real(ki_sam), dimension(0:3) :: R
   complex(ki_sam) :: Q2
   complex(ki_sam) ::denom1,denom2,denom3,denom4

   nonzero(:) = .true.
   Q2 = Q(4)*Q(4) - Q(1)*Q(1) - Q(2)*Q(2) - Q(3)*Q(3) - mu2

   select case(icut)
   case default
      R = real(k7+k8, ki_sam)
      denom1 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      denom2 = Q2
      R = real(-k3-k4, ki_sam)
      denom3 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      R = real(-k3-k6-k5-k4, ki_sam)
      denom4 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
   end select

   num = (0.0_ki_sam, 0.0_ki_sam)
   !-------#[ Diagram 9:
   if(nonzero(0)) then
      num = num - Nfrat * numerator_d9(icut, Q, mu2)
   end if
   !-------#] Diagram 9:
   !-------#[ Diagram 10:
   if(nonzero(1)) then
      num = num - Nfrat * numerator_d10(icut, Q, mu2)
   end if
   !-------#] Diagram 10:
   !-------#[ Diagram 11:
   if(nonzero(2)) then
      num = num - Nfrat * numerator_d11(icut, Q, mu2)
   end if
   !-------#] Diagram 11:
   !-------#[ Diagram 12:
   if(nonzero(3)) then
      num = num - Nfrat * numerator_d12(icut, Q, mu2)
   end if
   !-------#] Diagram 12:
end function numeval_group0
!-----#] function numeval_group0:
!-----#[ function numeval_group1:
function     numeval_group1(icut, Q, mu2) result(num)
   use P5B_uux_ddx_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P5B_uux_ddx_model
   use P5B_uux_ddx_d1h1l1, only: numerator_d1 => numerator_samurai
   use P5B_uux_ddx_d2h1l1, only: numerator_d2 => numerator_samurai
   use P5B_uux_ddx_d3h1l1, only: numerator_d3 => numerator_samurai
   use P5B_uux_ddx_d4h1l1, only: numerator_d4 => numerator_samurai
   implicit none
   integer, intent(in) :: icut
   complex(ki_sam), dimension(4), intent(in) :: Q
   real(ki_sam), intent(in) :: mu2
   complex(ki_sam) :: num

   logical, dimension(0:4-1) :: nonzero
   real(ki_sam), dimension(0:3) :: R
   complex(ki_sam) :: Q2
   complex(ki_sam) ::denom1,denom2,denom3,denom4

   nonzero(:) = .true.
   Q2 = Q(4)*Q(4) - Q(1)*Q(1) - Q(2)*Q(2) - Q(3)*Q(3) - mu2

   select case(icut)
   case default
      R = real(k7+k8+k5+k6, ki_sam)
      denom1 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      R = real(k7+k8, ki_sam)
      denom2 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      denom3 = Q2
      R = real(-k3-k4, ki_sam)
      denom4 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
   end select

   num = (0.0_ki_sam, 0.0_ki_sam)
   !-------#[ Diagram 1:
   if(nonzero(0)) then
      num = num - Nfrat * numerator_d1(icut, Q, mu2)
   end if
   !-------#] Diagram 1:
   !-------#[ Diagram 2:
   if(nonzero(1)) then
      num = num - Nfrat * numerator_d2(icut, Q, mu2)
   end if
   !-------#] Diagram 2:
   !-------#[ Diagram 3:
   if(nonzero(2)) then
      num = num - Nfrat * numerator_d3(icut, Q, mu2)
   end if
   !-------#] Diagram 3:
   !-------#[ Diagram 4:
   if(nonzero(3)) then
      num = num - Nfrat * numerator_d4(icut, Q, mu2)
   end if
   !-------#] Diagram 4:
end function numeval_group1
!-----#] function numeval_group1:
!-----#[ function numeval_group2:
function     numeval_group2(icut, Q, mu2) result(num)
   use P5B_uux_ddx_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P5B_uux_ddx_model
   use P5B_uux_ddx_d5h1l1, only: numerator_d5 => numerator_samurai
   use P5B_uux_ddx_d6h1l1, only: numerator_d6 => numerator_samurai
   use P5B_uux_ddx_d7h1l1, only: numerator_d7 => numerator_samurai
   use P5B_uux_ddx_d8h1l1, only: numerator_d8 => numerator_samurai
   use P5B_uux_ddx_d17h1l1, only: numerator_d17 => numerator_samurai
   use P5B_uux_ddx_d18h1l1, only: numerator_d18 => numerator_samurai
   use P5B_uux_ddx_d19h1l1, only: numerator_d19 => numerator_samurai
   use P5B_uux_ddx_d20h1l1, only: numerator_d20 => numerator_samurai
   use P5B_uux_ddx_d21h1l1, only: numerator_d21 => numerator_samurai
   use P5B_uux_ddx_d22h1l1, only: numerator_d22 => numerator_samurai
   use P5B_uux_ddx_d23h1l1, only: numerator_d23 => numerator_samurai
   use P5B_uux_ddx_d24h1l1, only: numerator_d24 => numerator_samurai
   use P5B_uux_ddx_d25h1l1, only: numerator_d25 => numerator_samurai
   use P5B_uux_ddx_d26h1l1, only: numerator_d26 => numerator_samurai
   use P5B_uux_ddx_d27h1l1, only: numerator_d27 => numerator_samurai
   use P5B_uux_ddx_d28h1l1, only: numerator_d28 => numerator_samurai
   use P5B_uux_ddx_d29h1l1, only: numerator_d29 => numerator_samurai
   use P5B_uux_ddx_d30h1l1, only: numerator_d30 => numerator_samurai
   use P5B_uux_ddx_d31h1l1, only: numerator_d31 => numerator_samurai
   use P5B_uux_ddx_d32h1l1, only: numerator_d32 => numerator_samurai
   implicit none
   integer, intent(in) :: icut
   complex(ki_sam), dimension(4), intent(in) :: Q
   real(ki_sam), intent(in) :: mu2
   complex(ki_sam) :: num

   logical, dimension(0:20-1) :: nonzero
   real(ki_sam), dimension(0:3) :: R
   complex(ki_sam) :: Q2
   complex(ki_sam) ::denom1,denom2,denom3,denom4

   nonzero(:) = .true.
   Q2 = Q(4)*Q(4) - Q(1)*Q(1) - Q(2)*Q(2) - Q(3)*Q(3) - mu2

   select case(icut)
   case(1)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      R = real(k7+k8+k5+k6, ki_sam)
      denom1 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      denom2 = 0.0_ki
      denom3 = Q2
      R = real(-k3-k4, ki_sam)
      denom4 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
   case(10)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      denom1 = 0.0_ki
      denom2 = 0.0_ki
      denom3 = Q2
      R = real(-k3-k4, ki_sam)
      denom4 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
   case(21)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      R = real(k7+k8+k5+k6, ki_sam)
      denom1 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      denom2 = 0.0_ki
      denom3 = 0.0_ki
      R = real(-k3-k4, ki_sam)
      denom4 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
   case(210)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      denom1 = 0.0_ki
      denom2 = 0.0_ki
      denom3 = 0.0_ki
      R = real(-k3-k4, ki_sam)
      denom4 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
   case(31)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      R = real(k7+k8+k5+k6, ki_sam)
      denom1 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      denom2 = 0.0_ki
      denom3 = Q2
      denom4 = 0.0_ki
   case(310)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      denom1 = 0.0_ki
      denom2 = 0.0_ki
      denom3 = Q2
      denom4 = 0.0_ki
   case(321)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      R = real(k7+k8+k5+k6, ki_sam)
      denom1 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      denom2 = 0.0_ki
      denom3 = 0.0_ki
      denom4 = 0.0_ki
   case(3210)
      nonzero(4) = .false.
      nonzero(5) = .false.
      nonzero(6) = .false.
      nonzero(7) = .false.
      nonzero(8) = .false.
      nonzero(9) = .false.
      nonzero(10) = .false.
      nonzero(11) = .false.
      nonzero(12) = .false.
      nonzero(13) = .false.
      nonzero(14) = .false.
      nonzero(15) = .false.
      nonzero(16) = .false.
      nonzero(17) = .false.
      nonzero(18) = .false.
      nonzero(19) = .false.
      denom1 = 0.0_ki
      denom2 = 0.0_ki
      denom3 = 0.0_ki
      denom4 = 0.0_ki
   case default
      R = real(k7+k8+k5+k6, ki_sam)
      denom1 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      R = real(k6+k5, ki_sam)
      denom2 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
      denom3 = Q2
      R = real(-k3-k4, ki_sam)
      denom4 = Q2 + (Q(4) + Q(4) + R(0))*R(0) &
                 &    - (Q(1) + Q(1) + R(1))*R(1) &
                 &    - (Q(2) + Q(2) + R(2))*R(2) &
                 &    - (Q(3) + Q(3) + R(3))*R(3)
   end select

   num = (0.0_ki_sam, 0.0_ki_sam)
   !-------#[ Diagram 5:
   if(nonzero(0)) then
      num = num - Nfrat * numerator_d5(icut, Q, mu2)
   end if
   !-------#] Diagram 5:
   !-------#[ Diagram 6:
   if(nonzero(1)) then
      num = num - Nfrat * numerator_d6(icut, Q, mu2)
   end if
   !-------#] Diagram 6:
   !-------#[ Diagram 7:
   if(nonzero(2)) then
      num = num - Nfrat * numerator_d7(icut, Q, mu2)
   end if
   !-------#] Diagram 7:
   !-------#[ Diagram 8:
   if(nonzero(3)) then
      num = num - Nfrat * numerator_d8(icut, Q, mu2)
   end if
   !-------#] Diagram 8:
   !-------#[ Diagram 17:
   if(nonzero(4)) then
      num = num - Nfrat * numerator_d17(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 17:
   !-------#[ Diagram 18:
   if(nonzero(5)) then
      num = num - Nfrat * numerator_d18(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 18:
   !-------#[ Diagram 19:
   if(nonzero(6)) then
      num = num - Nfrat * numerator_d19(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 19:
   !-------#[ Diagram 20:
   if(nonzero(7)) then
      num = num - Nfrat * numerator_d20(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 20:
   !-------#[ Diagram 21:
   if(nonzero(8)) then
      num = num - Nfrat * numerator_d21(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 21:
   !-------#[ Diagram 22:
   if(nonzero(9)) then
      num = num - Nfrat * numerator_d22(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 22:
   !-------#[ Diagram 23:
   if(nonzero(10)) then
      num = num - Nfrat * numerator_d23(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 23:
   !-------#[ Diagram 24:
   if(nonzero(11)) then
      num = num - Nfrat * numerator_d24(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 24:
   !-------#[ Diagram 25:
   if(nonzero(12)) then
      num = num - Nfrat * numerator_d25(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 25:
   !-------#[ Diagram 26:
   if(nonzero(13)) then
      num = num - Nfrat * numerator_d26(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 26:
   !-------#[ Diagram 27:
   if(nonzero(14)) then
      num = num - Nfrat * numerator_d27(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 27:
   !-------#[ Diagram 28:
   if(nonzero(15)) then
      num = num - Nfrat * numerator_d28(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 28:
   !-------#[ Diagram 29:
   if(nonzero(16)) then
      num = num - Nfrat * numerator_d29(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 29:
   !-------#[ Diagram 30:
   if(nonzero(17)) then
      num = num - Nfrat * numerator_d30(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 30:
   !-------#[ Diagram 31:
   if(nonzero(18)) then
      num = num - Nfrat * numerator_d31(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 31:
   !-------#[ Diagram 32:
   if(nonzero(19)) then
      num = num - Nfrat * numerator_d32(icut, Q, mu2) * denom2
   end if
   !-------#] Diagram 32:
end function numeval_group2
!-----#] function numeval_group2:
!---#] grouped numerators for samurai:
!---#[ reduce groups with samurai:
!-----#[ subroutine reduce_group0:
subroutine     reduce_group0(scale2,tot,totr,ok)
   use msamurai, only: samurai
   use options, only: samurai_out => iout
   use P5B_uux_ddx_config, only: samurai_group_numerators, &
      samurai_verbosity, samurai_istop, debug_nlo_diagrams, logfile
   use P5B_uux_ddx_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P5B_uux_ddx_model
   use P5B_uux_ddx_d9h1l1, only: numerator_diagram9 => numerator_samurai
   use P5B_uux_ddx_d10h1l1, only: numerator_diagram10 => numerator_samurai
   use P5B_uux_ddx_d11h1l1, only: numerator_diagram11 => numerator_samurai
   use P5B_uux_ddx_d12h1l1, only: numerator_diagram12 => numerator_samurai
   use P5B_uux_ddx_globalsl1, only: epspow
   implicit none
   real(ki_sam), intent(in) :: scale2
   complex(ki_sam), dimension(-2:0), intent(out) :: tot
   complex(ki_sam), intent(out) :: totr
   logical, intent(out) :: ok

   complex(ki_sam), dimension(-2:0) :: acc
   complex(ki_sam) :: accr
   logical :: acc_ok

   integer, parameter :: effective_group_rank = 4

   real(ki), dimension(4) :: msq
   real(ki), dimension(4,4) :: Vi
   msq(1) = 0.0_ki
   Vi(1,:) = k7((/2,3,4,1/))+k8((/2,3,4,1/))
   msq(2) = 0.0_ki
   Vi(2,:) = 0
   msq(3) = 0.0_ki
   Vi(3,:) = -k3((/2,3,4,1/))-k4((/2,3,4,1/))
   msq(4) = 0.0_ki
   Vi(4,:) = -k3((/2,3,4,1/))-k6((/2,3,4,1/))-k5((/2,3,4,1/))-k4((/2,3,4,1/))

   if(samurai_group_numerators) then
      !------#[ reduce numerator numeval_group0:
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numeval_group0"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numeval_group0, tot, totr, Vi, msq, 4, &
         & effective_group_rank, samurai_istop, scale2, ok)
      !------#] reduce numerator numeval_group0:
   else
      !------#[ sum over reduction of single diagrams:
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='9'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram9"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram9, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = - Nfrat * acc
      totr = - Nfrat * accr
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='10'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram10"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram10, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='11'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram11"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram11, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='12'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram12"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram12, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      !------#] sum over reduction of single diagrams:
   end if
end subroutine reduce_group0
!-----#] subroutine reduce_group0:
!-----#[ subroutine reduce_group1:
subroutine     reduce_group1(scale2,tot,totr,ok)
   use msamurai, only: samurai
   use options, only: samurai_out => iout
   use P5B_uux_ddx_config, only: samurai_group_numerators, &
      samurai_verbosity, samurai_istop, debug_nlo_diagrams, logfile
   use P5B_uux_ddx_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P5B_uux_ddx_model
   use P5B_uux_ddx_d1h1l1, only: numerator_diagram1 => numerator_samurai
   use P5B_uux_ddx_d2h1l1, only: numerator_diagram2 => numerator_samurai
   use P5B_uux_ddx_d3h1l1, only: numerator_diagram3 => numerator_samurai
   use P5B_uux_ddx_d4h1l1, only: numerator_diagram4 => numerator_samurai
   use P5B_uux_ddx_globalsl1, only: epspow
   implicit none
   real(ki_sam), intent(in) :: scale2
   complex(ki_sam), dimension(-2:0), intent(out) :: tot
   complex(ki_sam), intent(out) :: totr
   logical, intent(out) :: ok

   complex(ki_sam), dimension(-2:0) :: acc
   complex(ki_sam) :: accr
   logical :: acc_ok

   integer, parameter :: effective_group_rank = 4

   real(ki), dimension(4) :: msq
   real(ki), dimension(4,4) :: Vi
   msq(1) = 0.0_ki
   Vi(1,:) = k7((/2,3,4,1/))+k8((/2,3,4,1/))+k5((/2,3,4,1/))+k6((/2,3,4,1/))
   msq(2) = 0.0_ki
   Vi(2,:) = k7((/2,3,4,1/))+k8((/2,3,4,1/))
   msq(3) = 0.0_ki
   Vi(3,:) = 0
   msq(4) = 0.0_ki
   Vi(4,:) = -k3((/2,3,4,1/))-k4((/2,3,4,1/))

   if(samurai_group_numerators) then
      !------#[ reduce numerator numeval_group1:
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numeval_group1"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numeval_group1, tot, totr, Vi, msq, 4, &
         & effective_group_rank, samurai_istop, scale2, ok)
      !------#] reduce numerator numeval_group1:
   else
      !------#[ sum over reduction of single diagrams:
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='1'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram1"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram1, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = - Nfrat * acc
      totr = - Nfrat * accr
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='2'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram2"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram2, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='3'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram3"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram3, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='4'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram4"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram4, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      !------#] sum over reduction of single diagrams:
   end if
end subroutine reduce_group1
!-----#] subroutine reduce_group1:
!-----#[ subroutine reduce_group2:
subroutine     reduce_group2(scale2,tot,totr,ok)
   use msamurai, only: samurai
   use options, only: samurai_out => iout
   use P5B_uux_ddx_config, only: samurai_group_numerators, &
      samurai_verbosity, samurai_istop, debug_nlo_diagrams, logfile
   use P5B_uux_ddx_kinematics, only: k1, k2, k3, k4, k5, k6, k7, k8
   use P5B_uux_ddx_model
   use P5B_uux_ddx_d5h1l1, only: numerator_diagram5 => numerator_samurai
   use P5B_uux_ddx_d6h1l1, only: numerator_diagram6 => numerator_samurai
   use P5B_uux_ddx_d7h1l1, only: numerator_diagram7 => numerator_samurai
   use P5B_uux_ddx_d8h1l1, only: numerator_diagram8 => numerator_samurai
   use P5B_uux_ddx_d17h1l1, only: numerator_diagram17 => numerator_samurai
   use P5B_uux_ddx_d18h1l1, only: numerator_diagram18 => numerator_samurai
   use P5B_uux_ddx_d19h1l1, only: numerator_diagram19 => numerator_samurai
   use P5B_uux_ddx_d20h1l1, only: numerator_diagram20 => numerator_samurai
   use P5B_uux_ddx_d21h1l1, only: numerator_diagram21 => numerator_samurai
   use P5B_uux_ddx_d22h1l1, only: numerator_diagram22 => numerator_samurai
   use P5B_uux_ddx_d23h1l1, only: numerator_diagram23 => numerator_samurai
   use P5B_uux_ddx_d24h1l1, only: numerator_diagram24 => numerator_samurai
   use P5B_uux_ddx_d25h1l1, only: numerator_diagram25 => numerator_samurai
   use P5B_uux_ddx_d26h1l1, only: numerator_diagram26 => numerator_samurai
   use P5B_uux_ddx_d27h1l1, only: numerator_diagram27 => numerator_samurai
   use P5B_uux_ddx_d28h1l1, only: numerator_diagram28 => numerator_samurai
   use P5B_uux_ddx_d29h1l1, only: numerator_diagram29 => numerator_samurai
   use P5B_uux_ddx_d30h1l1, only: numerator_diagram30 => numerator_samurai
   use P5B_uux_ddx_d31h1l1, only: numerator_diagram31 => numerator_samurai
   use P5B_uux_ddx_d32h1l1, only: numerator_diagram32 => numerator_samurai
   use P5B_uux_ddx_globalsl1, only: epspow
   implicit none
   real(ki_sam), intent(in) :: scale2
   complex(ki_sam), dimension(-2:0), intent(out) :: tot
   complex(ki_sam), intent(out) :: totr
   logical, intent(out) :: ok

   complex(ki_sam), dimension(-2:0) :: acc
   complex(ki_sam) :: accr
   logical :: acc_ok

   integer, parameter :: effective_group_rank = 4

   real(ki), dimension(4) :: msq
   real(ki), dimension(4,4) :: Vi
   msq(1) = 0.0_ki
   Vi(1,:) = k7((/2,3,4,1/))+k8((/2,3,4,1/))+k5((/2,3,4,1/))+k6((/2,3,4,1/))
   msq(2) = 0.0_ki
   Vi(2,:) = k6((/2,3,4,1/))+k5((/2,3,4,1/))
   msq(3) = 0.0_ki
   Vi(3,:) = 0
   msq(4) = 0.0_ki
   Vi(4,:) = -k3((/2,3,4,1/))-k4((/2,3,4,1/))

   if(samurai_group_numerators) then
      !------#[ reduce numerator numeval_group2:
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numeval_group2"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numeval_group2, tot, totr, Vi, msq, 4, &
         & effective_group_rank, samurai_istop, scale2, ok)
      !------#] reduce numerator numeval_group2:
   else
      !------#[ sum over reduction of single diagrams:
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='5'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram5"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram5, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = - Nfrat * acc
      totr = - Nfrat * accr
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='6'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram6"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram6, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='7'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram7"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram7, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='8'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram8"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram8, acc, accr, &
         & Vi((/1,2,3,4/),:), msq((/1,2,3,4/)), 4, &
         & 4, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='17'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram17"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram17, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='18'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram18"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram18, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='19'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram19"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram19, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='20'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram20"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram20, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='21'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram21"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram21, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='22'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram22"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram22, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='23'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram23"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram23, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='24'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram24"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram24, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='25'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram25"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram25, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='26'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram26"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram26, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='27'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram27"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram27, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='28'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram28"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram28, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='29'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram29"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram29, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='30'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram30"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram30, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='31'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram31"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram31, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      if(debug_nlo_diagrams) then
         write(logfile,*) "<diagram index='32'>"
      end if
      if(samurai_verbosity > 0) then
         write(samurai_out,*) "[golem-2.0] numerator_diagram32"
         write(samurai_out,*) "[golem-2.0] epspow=", epspow
      end if
      call samurai(numerator_diagram32, acc, accr, &
         & Vi((/1,3,4/),:), msq((/1,3,4/)), 3, &
         & 3, samurai_istop, scale2, acc_ok)

      if(debug_nlo_diagrams) then
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-finite' re='", real(acc(0), ki), &
            & "' im='", aimag(acc(0)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-single' re='", real(acc(-1), ki), &
            & "' im='", aimag(acc(-1)), "'/>"
         write(logfile,'(A30,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-double' re='", real(acc(-2), ki), &
            & "' im='", aimag(acc(-2)), "'/>"
         write(logfile,'(A32,E24.16,A6,E24.16,A3)') &
            & "<result kind='nlo-rational' re='", real(accr, ki), &
            & "' im='", aimag(accr), "'/>"
         if(ok) then
            write(logfile,'(A30)') "<flag name='ok' status='yes'/>"
         else
            write(logfile,'(A29)') "<flag name='ok' status='no'/>"
         end if
         write(logfile,*) "</diagram>"
      end if

      tot = tot - Nfrat * acc
      totr = totr - Nfrat * accr
      ok = ok .and. acc_ok
      !------#] sum over reduction of single diagrams:
   end if
end subroutine reduce_group2
!-----#] subroutine reduce_group2:
!---#] reduce groups with samurai:
end module P5B_uux_ddx_samuraih1
