module     P5B_uux_ddx_d12h3l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P5B_uux_
   ! ddx/helicity3/d12h3l1.f90
   ! generator: haggies (1.1)
   use P5B_uux_ddx_config, only: ki
   use P5B_uux_ddx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P5B_uux_ddx_groups, only: &
!           & sign => diagram12_sign, shift => diagram12_shift
      use P5B_uux_ddx_globalsl1, only: epspow
      use P5B_uux_ddx_kinematics
      use P5B_uux_ddx_abbrevd12h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d12
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k6-k5-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d12 = 0.0_ki
      t1 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t2 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4))
      t3 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t4 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t5 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t6 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t7 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t8 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t9 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t10 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t11 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t12 = t4*abb12n25
      t13 = t4*abb12n27
      t14 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t15 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      d12 = (t1*abb12n10+t10*t13+t10*abb12n9+t11*t13+t11*abb12n9+t12*t8+t12*t9+t&
      &2*abb12n13+t3*abb12n18+t4*abb12n22+t4*t4*abb12n26+t5*abb12n6+t6*abb12n6+t&
      &7*abb12n7+t8*abb12n8+t9*abb12n8+t1*t2*abb12n14+t1*t3*abb12n5+t1*t4*abb12n&
      &24+t1*t7*abb12n28+t10*t7*abb12n3+t11*t7*abb12n3+t14*t4*abb12n37+t14*t5*ab&
      &b12n36+t14*t7*abb12n35+t2*t4*abb12n30+t2*t5*abb12n11+t2*t6*abb12n11+t2*t7&
      &*abb12n12+t3*t4*abb12n23+t3*t5*abb12n2+t3*t6*abb12n2+t3*t7*abb12n16+t4*t5&
      &*abb12n20+t4*t7*abb12n17+t7*t8*abb12n4+t7*t9*abb12n4+t1*t14*t7*abb12n32+t&
      &1*t2*t4*abb12n31+t1*t2*t7*abb12n15+t1*t3*t4*abb12n19+t1*t4*t7*abb12n29+t1&
      &*t4*abb12n21*(Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spv&
      &ak2k8(4))+t10*t14*t7*abb12n39+t11*t14*t7*abb12n39+t14*t15*t4*abb12n38+t14&
      &*t15*t7*abb12n42+t14*t3*t4*abb12n33+t14*t3*t5*abb12n34+t14*t3*t7*abb12n43&
      &+t14*t4*t7*abb12n40+t14*t4*abb12n44*(Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(&
      &3)*spvak3k8(3)-Q(4)*spvak3k8(4))+t14*t7*t8*abb12n41+t14*t7*t9*abb12n41+t1&
      &*t14*t3*t7*abb12n45)
      numerator = cmplx(real(d12, ki), aimag(d12), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P5B_uux_ddx_globalsl1, only: epspow
      use P5B_uux_ddx_kinematics
      use P5B_uux_ddx_abbrevd12h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d12
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k6-k5-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d12 = 0.0_ki
      t1 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t2 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4))
      t3 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4))
      t4 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t5 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t6 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t7 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t8 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t9 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t10 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t11 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t12 = t4*abb12n25
      t13 = t4*abb12n27
      t14 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t15 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      d12 = (t1*abb12n10+t10*t13+t10*abb12n9+t11*t13+t11*abb12n9+t12*t8+t12*t9+t&
      &2*abb12n13+t3*abb12n18+t4*abb12n22+t4*t4*abb12n26+t5*abb12n6+t6*abb12n6+t&
      &7*abb12n7+t8*abb12n8+t9*abb12n8+t1*t2*abb12n14+t1*t3*abb12n5+t1*t4*abb12n&
      &24+t1*t7*abb12n28+t10*t7*abb12n3+t11*t7*abb12n3+t14*t4*abb12n37+t14*t5*ab&
      &b12n36+t14*t7*abb12n35+t2*t4*abb12n30+t2*t5*abb12n11+t2*t6*abb12n11+t2*t7&
      &*abb12n12+t3*t4*abb12n23+t3*t5*abb12n2+t3*t6*abb12n2+t3*t7*abb12n16+t4*t5&
      &*abb12n20+t4*t7*abb12n17+t7*t8*abb12n4+t7*t9*abb12n4+t1*t14*t7*abb12n32+t&
      &1*t2*t4*abb12n31+t1*t2*t7*abb12n15+t1*t3*t4*abb12n19+t1*t4*t7*abb12n29+t1&
      &*t4*abb12n21*(Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spv&
      &ak2k8(4))+t10*t14*t7*abb12n39+t11*t14*t7*abb12n39+t14*t15*t4*abb12n38+t14&
      &*t15*t7*abb12n42+t14*t3*t4*abb12n33+t14*t3*t5*abb12n34+t14*t3*t7*abb12n43&
      &+t14*t4*t7*abb12n40+t14*t4*abb12n44*(Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(&
      &3)*spvak3k8(3)-Q(4)*spvak3k8(4))+t14*t7*t8*abb12n41+t14*t7*t9*abb12n41+t1&
      &*t14*t3*t7*abb12n45)

      numerator = cmplx(real(d12, ki), aimag(d12), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P5B_uux_ddx_d12h3l1
