module     P5B_uux_ddx_d24h3l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P5B_uux_
   ! ddx/helicity3/d24h3l1.f90
   ! generator: haggies (1.1)
   use P5B_uux_ddx_config, only: ki
   use P5B_uux_ddx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P5B_uux_ddx_groups, only: &
!           & sign => diagram24_sign, shift => diagram24_shift
      use P5B_uux_ddx_globalsl1, only: epspow
      use P5B_uux_ddx_kinematics
      use P5B_uux_ddx_abbrevd24h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d24
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d24 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t5 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t6 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t7 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      t8 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t9 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t10 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t11 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t12 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t13 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4)&
      &)
      t14 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t15 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t16 = (Q(1)*spvak2k7(1)-Q(2)*spvak2k7(2)-Q(3)*spvak2k7(3)-Q(4)*spvak2k7(4)&
      &)
      t17 = (Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4)&
      &)
      t18 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t19 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t20 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t21 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t22 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4)&
      &)
      t23 = (Q(1)*spvak8k1(1)-Q(2)*spvak8k1(2)-Q(3)*spvak8k1(3)-Q(4)*spvak8k1(4)&
      &)
      t24 = t3*abb24n5
      t25 = t3*abb24n6
      d24 = (t1*abb24n14+t10*t25+t2*abb24n31+t24*t6+t24*t8+t25*t9+t3*abb24n32+t4&
      &*abb24n49+t1*t18*abb24n36+t10*t19*abb24n37+t10*t7*abb24n17+t11*t12*abb24n&
      &8+t11*t14*abb24n8+t11*t19*abb24n39+t11*t3*abb24n7+t11*t7*abb24n18+t12*t13&
      &*abb24n20+t12*t15*abb24n21+t12*t16*abb24n22+t12*t17*abb24n23+t12*t18*abb2&
      &4n34+t12*t20*abb24n41+t12*t21*abb24n42+t12*t22*abb24n43+t12*t23*abb24n44+&
      &t12*t4*abb24n51+t12*t5*abb24n9+t13*t14*abb24n20+t13*t18*abb24n24+t14*t15*&
      &abb24n21+t14*t16*abb24n22+t14*t17*abb24n23+t14*t18*abb24n34+t14*t20*abb24&
      &n41+t14*t21*abb24n42+t14*t22*abb24n43+t14*t23*abb24n44+t14*t4*abb24n51+t1&
      &4*t5*abb24n9+t15*t18*abb24n25+t16*t18*abb24n26+t17*t18*abb24n27+t18*t2*ab&
      &b24n36+t18*t20*abb24n46+t18*t21*abb24n45+t18*t22*abb24n48+t18*t23*abb24n4&
      &7+t18*t3*abb24n35+t18*t4*abb24n52+t19*t5*abb24n40+t19*t6*abb24n38+t19*t8*&
      &abb24n38+t19*t9*abb24n37+t3*t4*abb24n50+t3*t5*abb24n10+t3*abb24n11*(Q(1)*&
      &spvak3k5(1)-Q(2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4))+t3*abb24n&
      &12*(Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))+&
      &t3*abb24n13*(Q(1)*spvak3k7(1)-Q(2)*spvak3k7(2)-Q(3)*spvak3k7(3)-Q(4)*spva&
      &k3k7(4))+t3*abb24n15*(Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-&
      &Q(4)*spvak3k8(4))+t3*abb24n28*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spv&
      &ak5k4(3)-Q(4)*spvak5k4(4))+t3*abb24n29*(Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)&
      &-Q(3)*spvak6k4(3)-Q(4)*spvak6k4(4))+t3*abb24n30*(Q(1)*spvak7k4(1)-Q(2)*sp&
      &vak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4))+t3*abb24n33*(Q(1)*spvak8k4(1&
      &)-Q(2)*spvak8k4(2)-Q(3)*spvak8k4(3)-Q(4)*spvak8k4(4))+t5*t7*abb24n19+t6*t&
      &7*abb24n16+t7*t8*abb24n16+t7*t9*abb24n17+t10*t18*t4*abb24n53+t11*t18*t4*a&
      &bb24n55+t18*t4*t5*abb24n56+t18*t4*t6*abb24n54+t18*t4*t8*abb24n54+t18*t4*t&
      &9*abb24n53)
      numerator = cmplx(real(d24, ki), aimag(d24), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P5B_uux_ddx_globalsl1, only: epspow
      use P5B_uux_ddx_kinematics
      use P5B_uux_ddx_abbrevd24h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d24
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d24 = 0.0_ki
      t1 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t4 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t5 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t6 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t7 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))
      t8 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t9 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t10 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t11 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t12 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t13 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4)&
      &)
      t14 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t15 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t16 = (Q(1)*spvak2k7(1)-Q(2)*spvak2k7(2)-Q(3)*spvak2k7(3)-Q(4)*spvak2k7(4)&
      &)
      t17 = (Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4)&
      &)
      t18 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t19 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t20 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t21 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)&
      &)
      t22 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4)&
      &)
      t23 = (Q(1)*spvak8k1(1)-Q(2)*spvak8k1(2)-Q(3)*spvak8k1(3)-Q(4)*spvak8k1(4)&
      &)
      t24 = t3*abb24n5
      t25 = t3*abb24n6
      d24 = (t1*abb24n14+t10*t25+t2*abb24n31+t24*t6+t24*t8+t25*t9+t3*abb24n32+t4&
      &*abb24n49+t1*t18*abb24n36+t10*t19*abb24n37+t10*t7*abb24n17+t11*t12*abb24n&
      &8+t11*t14*abb24n8+t11*t19*abb24n39+t11*t3*abb24n7+t11*t7*abb24n18+t12*t13&
      &*abb24n20+t12*t15*abb24n21+t12*t16*abb24n22+t12*t17*abb24n23+t12*t18*abb2&
      &4n34+t12*t20*abb24n41+t12*t21*abb24n42+t12*t22*abb24n43+t12*t23*abb24n44+&
      &t12*t4*abb24n51+t12*t5*abb24n9+t13*t14*abb24n20+t13*t18*abb24n24+t14*t15*&
      &abb24n21+t14*t16*abb24n22+t14*t17*abb24n23+t14*t18*abb24n34+t14*t20*abb24&
      &n41+t14*t21*abb24n42+t14*t22*abb24n43+t14*t23*abb24n44+t14*t4*abb24n51+t1&
      &4*t5*abb24n9+t15*t18*abb24n25+t16*t18*abb24n26+t17*t18*abb24n27+t18*t2*ab&
      &b24n36+t18*t20*abb24n46+t18*t21*abb24n45+t18*t22*abb24n48+t18*t23*abb24n4&
      &7+t18*t3*abb24n35+t18*t4*abb24n52+t19*t5*abb24n40+t19*t6*abb24n38+t19*t8*&
      &abb24n38+t19*t9*abb24n37+t3*t4*abb24n50+t3*t5*abb24n10+t3*abb24n11*(Q(1)*&
      &spvak3k5(1)-Q(2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4))+t3*abb24n&
      &12*(Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))+&
      &t3*abb24n13*(Q(1)*spvak3k7(1)-Q(2)*spvak3k7(2)-Q(3)*spvak3k7(3)-Q(4)*spva&
      &k3k7(4))+t3*abb24n15*(Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-&
      &Q(4)*spvak3k8(4))+t3*abb24n28*(Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spv&
      &ak5k4(3)-Q(4)*spvak5k4(4))+t3*abb24n29*(Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)&
      &-Q(3)*spvak6k4(3)-Q(4)*spvak6k4(4))+t3*abb24n30*(Q(1)*spvak7k4(1)-Q(2)*sp&
      &vak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4))+t3*abb24n33*(Q(1)*spvak8k4(1&
      &)-Q(2)*spvak8k4(2)-Q(3)*spvak8k4(3)-Q(4)*spvak8k4(4))+t5*t7*abb24n19+t6*t&
      &7*abb24n16+t7*t8*abb24n16+t7*t9*abb24n17+t10*t18*t4*abb24n53+t11*t18*t4*a&
      &bb24n55+t18*t4*t5*abb24n56+t18*t4*t6*abb24n54+t18*t4*t8*abb24n54+t18*t4*t&
      &9*abb24n53)

      numerator = cmplx(real(d24, ki), aimag(d24), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P5B_uux_ddx_d24h3l1
