module     P5B_uux_ddx_d27h3l1
   ! file:      /afs/ipp-garching.mpg.de/home/g/gdh/Golem/gosam/working/P5B_uux_
   ! ddx/helicity3/d27h3l1.f90
   ! generator: haggies (1.1)
   use P5B_uux_ddx_config, only: ki
   use P5B_uux_ddx_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use P5B_uux_ddx_groups, only: &
!           & sign => diagram27_sign, shift => diagram27_shift
      use P5B_uux_ddx_globalsl1, only: epspow
      use P5B_uux_ddx_kinematics
      use P5B_uux_ddx_abbrevd27h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      real(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d27
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d27 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t3 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t4 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t5 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t6 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t7 = t1*abb27n13
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t10 = t1*abb27n14
      t11 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t12 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t13 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t14 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t15 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t16 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t17 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t18 = (Q(1)*spvak3k5(1)-Q(2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4)&
      &)
      t19 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)&
      &)
      t20 = (Q(1)*spvak3k7(1)-Q(2)*spvak3k7(2)-Q(3)*spvak3k7(3)-Q(4)*spvak3k7(4)&
      &)
      t21 = (Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4)&
      &)
      t22 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t23 = (Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4)&
      &)
      t24 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t25 = (Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(3)*spvak6k4(3)-Q(4)*spvak6k4(4)&
      &)
      t26 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t27 = (Q(1)*spvak8k4(1)-Q(2)*spvak8k4(2)-Q(3)*spvak8k4(3)-Q(4)*spvak8k4(4)&
      &)
      t28 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t29 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4)&
      &)
      d27 = (t1*abb27n10+t1*abb27n12+t1*abb27n56+t10*t11+t10*t9+t2*abb27n27+t3*a&
      &bb27n32+t4*abb27n37+t4*abb27n9+t6*t7+t7*t8+t1*t13*abb27n16+t1*t15*abb27n1&
      &7+t1*t18*abb27n39+t1*t19*abb27n41+t1*t20*abb27n42+t1*t21*abb27n44+t1*t22*&
      &abb27n46+t1*t23*abb27n49+t1*t24*abb27n50+t1*t25*abb27n52+t1*t26*abb27n55+&
      &t1*t27*abb27n58+t1*t28*abb27n64+t1*t29*abb27n65+t1*t4*abb27n20+t1*t5*abb2&
      &7n21+t11*t16*abb27n29+t11*t17*abb27n34+t12*t13*abb27n15+t12*t15*abb27n18+&
      &t12*t18*abb27n38+t12*t19*abb27n40+t12*t20*abb27n43+t12*t21*abb27n45+t12*t&
      &22*abb27n47+t12*t23*abb27n48+t12*t24*abb27n51+t12*t25*abb27n53+t12*t26*ab&
      &b27n54+t12*t27*abb27n57+t12*t28*abb27n63+t12*t29*abb27n66+t12*t4*abb27n19&
      &+t12*t5*abb27n22+t13*t14*abb27n15+t13*t16*abb27n30+t13*t17*abb27n35+t14*t&
      &15*abb27n18+t14*t18*abb27n38+t14*t19*abb27n40+t14*t20*abb27n43+t14*t21*ab&
      &b27n45+t14*t22*abb27n47+t14*t23*abb27n48+t14*t24*abb27n51+t14*t25*abb27n5&
      &3+t14*t26*abb27n54+t14*t27*abb27n57+t14*t28*abb27n63+t14*t29*abb27n66+t14&
      &*t4*abb27n19+t14*t5*abb27n22+t15*t16*abb27n31+t15*t17*abb27n36+t16*t6*abb&
      &27n28+t16*t8*abb27n28+t16*t9*abb27n29+t17*t6*abb27n33+t17*t8*abb27n33+t17&
      &*t9*abb27n34+t18*t5*abb27n67+t19*t5*abb27n68+t2*t5*abb27n71+t20*t5*abb27n&
      &69+t21*t5*abb27n70+t24*t5*abb27n60+t25*t5*abb27n59+t26*t5*abb27n62+t27*t5&
      &*abb27n61+t3*t5*abb27n72+t4*t5*abb27n11+t4*t5*abb27n73+t11*t4*t5*abb27n23&
      &+t13*t4*t5*abb27n25+t15*t4*t5*abb27n26+t4*t5*t6*abb27n24+t4*t5*t8*abb27n2&
      &4+t4*t5*t9*abb27n23)
      numerator = cmplx(real(d27, ki), aimag(d27), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use P5B_uux_ddx_globalsl1, only: epspow
      use P5B_uux_ddx_kinematics
      use P5B_uux_ddx_abbrevd27h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d27
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d27 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t3 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t4 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t5 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t6 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t7 = t1*abb27n13
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*k7(1)-Q(2)*k7(2)-Q(3)*k7(3)-Q(4)*k7(4))
      t10 = t1*abb27n14
      t11 = (Q(1)*k8(1)-Q(2)*k8(2)-Q(3)*k8(3)-Q(4)*k8(4))
      t12 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t13 = (Q(1)*spvak7k8(1)-Q(2)*spvak7k8(2)-Q(3)*spvak7k8(3)-Q(4)*spvak7k8(4)&
      &)
      t14 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t15 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t16 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      t17 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t18 = (Q(1)*spvak3k5(1)-Q(2)*spvak3k5(2)-Q(3)*spvak3k5(3)-Q(4)*spvak3k5(4)&
      &)
      t19 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)&
      &)
      t20 = (Q(1)*spvak3k7(1)-Q(2)*spvak3k7(2)-Q(3)*spvak3k7(3)-Q(4)*spvak3k7(4)&
      &)
      t21 = (Q(1)*spvak3k8(1)-Q(2)*spvak3k8(2)-Q(3)*spvak3k8(3)-Q(4)*spvak3k8(4)&
      &)
      t22 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t23 = (Q(1)*spvak2k8(1)-Q(2)*spvak2k8(2)-Q(3)*spvak2k8(3)-Q(4)*spvak2k8(4)&
      &)
      t24 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      t25 = (Q(1)*spvak6k4(1)-Q(2)*spvak6k4(2)-Q(3)*spvak6k4(3)-Q(4)*spvak6k4(4)&
      &)
      t26 = (Q(1)*spvak7k4(1)-Q(2)*spvak7k4(2)-Q(3)*spvak7k4(3)-Q(4)*spvak7k4(4)&
      &)
      t27 = (Q(1)*spvak8k4(1)-Q(2)*spvak8k4(2)-Q(3)*spvak8k4(3)-Q(4)*spvak8k4(4)&
      &)
      t28 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t29 = (Q(1)*spvak7k1(1)-Q(2)*spvak7k1(2)-Q(3)*spvak7k1(3)-Q(4)*spvak7k1(4)&
      &)
      d27 = (t1*abb27n10+t1*abb27n12+t1*abb27n56+t10*t11+t10*t9+t2*abb27n27+t3*a&
      &bb27n32+t4*abb27n37+t4*abb27n9+t6*t7+t7*t8+t1*t13*abb27n16+t1*t15*abb27n1&
      &7+t1*t18*abb27n39+t1*t19*abb27n41+t1*t20*abb27n42+t1*t21*abb27n44+t1*t22*&
      &abb27n46+t1*t23*abb27n49+t1*t24*abb27n50+t1*t25*abb27n52+t1*t26*abb27n55+&
      &t1*t27*abb27n58+t1*t28*abb27n64+t1*t29*abb27n65+t1*t4*abb27n20+t1*t5*abb2&
      &7n21+t11*t16*abb27n29+t11*t17*abb27n34+t12*t13*abb27n15+t12*t15*abb27n18+&
      &t12*t18*abb27n38+t12*t19*abb27n40+t12*t20*abb27n43+t12*t21*abb27n45+t12*t&
      &22*abb27n47+t12*t23*abb27n48+t12*t24*abb27n51+t12*t25*abb27n53+t12*t26*ab&
      &b27n54+t12*t27*abb27n57+t12*t28*abb27n63+t12*t29*abb27n66+t12*t4*abb27n19&
      &+t12*t5*abb27n22+t13*t14*abb27n15+t13*t16*abb27n30+t13*t17*abb27n35+t14*t&
      &15*abb27n18+t14*t18*abb27n38+t14*t19*abb27n40+t14*t20*abb27n43+t14*t21*ab&
      &b27n45+t14*t22*abb27n47+t14*t23*abb27n48+t14*t24*abb27n51+t14*t25*abb27n5&
      &3+t14*t26*abb27n54+t14*t27*abb27n57+t14*t28*abb27n63+t14*t29*abb27n66+t14&
      &*t4*abb27n19+t14*t5*abb27n22+t15*t16*abb27n31+t15*t17*abb27n36+t16*t6*abb&
      &27n28+t16*t8*abb27n28+t16*t9*abb27n29+t17*t6*abb27n33+t17*t8*abb27n33+t17&
      &*t9*abb27n34+t18*t5*abb27n67+t19*t5*abb27n68+t2*t5*abb27n71+t20*t5*abb27n&
      &69+t21*t5*abb27n70+t24*t5*abb27n60+t25*t5*abb27n59+t26*t5*abb27n62+t27*t5&
      &*abb27n61+t3*t5*abb27n72+t4*t5*abb27n11+t4*t5*abb27n73+t11*t4*t5*abb27n23&
      &+t13*t4*t5*abb27n25+t15*t4*t5*abb27n26+t4*t5*t6*abb27n24+t4*t5*t8*abb27n2&
      &4+t4*t5*t9*abb27n23)

      numerator = cmplx(real(d27, ki), aimag(d27), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module P5B_uux_ddx_d27h3l1
