module     P5B_uux_ddx_golem95h3
   use precision_golem, only: ki_gol => ki
   use P5B_uux_ddx_config, only: ki
   implicit none
   private
   interface reconstruct_group
      module procedure reconstruct_group0
      module procedure reconstruct_group1
      module procedure reconstruct_group2
   end interface

   public :: reconstruct_group
contains
!---#[ subroutine reconstruct_group0:
subroutine     reconstruct_group0(coeffs)
   use tens_rec
   use P5B_uux_ddx_groups, only: tensrec_info_group0
   use P5B_uux_ddx_d9h3l1, only: numerator_d9 => numerator_golem95
   use P5B_uux_ddx_d10h3l1, only: numerator_d10 => numerator_golem95
   use P5B_uux_ddx_d11h3l1, only: numerator_d11 => numerator_golem95
   use P5B_uux_ddx_d12h3l1, only: numerator_d12 => numerator_golem95
   implicit none
   type(tensrec_info_group0), intent(out) :: coeffs
   !------#[ Diagram 9:
      call reconstruct4(numerator_d9, coeffs%coeffs_9)
   !------#] Diagram 9:
   !------#[ Diagram 10:
      call reconstruct4(numerator_d10, coeffs%coeffs_10)
   !------#] Diagram 10:
   !------#[ Diagram 11:
      call reconstruct4(numerator_d11, coeffs%coeffs_11)
   !------#] Diagram 11:
   !------#[ Diagram 12:
      call reconstruct4(numerator_d12, coeffs%coeffs_12)
   !------#] Diagram 12:
end subroutine reconstruct_group0
!---#] subroutine reconstruct_group0:
!---#[ subroutine reconstruct_group1:
subroutine     reconstruct_group1(coeffs)
   use tens_rec
   use P5B_uux_ddx_groups, only: tensrec_info_group1
   use P5B_uux_ddx_d1h3l1, only: numerator_d1 => numerator_golem95
   use P5B_uux_ddx_d2h3l1, only: numerator_d2 => numerator_golem95
   use P5B_uux_ddx_d3h3l1, only: numerator_d3 => numerator_golem95
   use P5B_uux_ddx_d4h3l1, only: numerator_d4 => numerator_golem95
   implicit none
   type(tensrec_info_group1), intent(out) :: coeffs
   !------#[ Diagram 1:
      call reconstruct4(numerator_d1, coeffs%coeffs_1)
   !------#] Diagram 1:
   !------#[ Diagram 2:
      call reconstruct4(numerator_d2, coeffs%coeffs_2)
   !------#] Diagram 2:
   !------#[ Diagram 3:
      call reconstruct4(numerator_d3, coeffs%coeffs_3)
   !------#] Diagram 3:
   !------#[ Diagram 4:
      call reconstruct4(numerator_d4, coeffs%coeffs_4)
   !------#] Diagram 4:
end subroutine reconstruct_group1
!---#] subroutine reconstruct_group1:
!---#[ subroutine reconstruct_group2:
subroutine     reconstruct_group2(coeffs)
   use tens_rec
   use P5B_uux_ddx_groups, only: tensrec_info_group2
   use P5B_uux_ddx_d5h3l1, only: numerator_d5 => numerator_golem95
   use P5B_uux_ddx_d6h3l1, only: numerator_d6 => numerator_golem95
   use P5B_uux_ddx_d7h3l1, only: numerator_d7 => numerator_golem95
   use P5B_uux_ddx_d8h3l1, only: numerator_d8 => numerator_golem95
   use P5B_uux_ddx_d17h3l1, only: numerator_d17 => numerator_golem95
   use P5B_uux_ddx_d18h3l1, only: numerator_d18 => numerator_golem95
   use P5B_uux_ddx_d19h3l1, only: numerator_d19 => numerator_golem95
   use P5B_uux_ddx_d20h3l1, only: numerator_d20 => numerator_golem95
   use P5B_uux_ddx_d21h3l1, only: numerator_d21 => numerator_golem95
   use P5B_uux_ddx_d22h3l1, only: numerator_d22 => numerator_golem95
   use P5B_uux_ddx_d23h3l1, only: numerator_d23 => numerator_golem95
   use P5B_uux_ddx_d24h3l1, only: numerator_d24 => numerator_golem95
   use P5B_uux_ddx_d25h3l1, only: numerator_d25 => numerator_golem95
   use P5B_uux_ddx_d26h3l1, only: numerator_d26 => numerator_golem95
   use P5B_uux_ddx_d27h3l1, only: numerator_d27 => numerator_golem95
   use P5B_uux_ddx_d28h3l1, only: numerator_d28 => numerator_golem95
   use P5B_uux_ddx_d29h3l1, only: numerator_d29 => numerator_golem95
   use P5B_uux_ddx_d30h3l1, only: numerator_d30 => numerator_golem95
   use P5B_uux_ddx_d31h3l1, only: numerator_d31 => numerator_golem95
   use P5B_uux_ddx_d32h3l1, only: numerator_d32 => numerator_golem95
   implicit none
   type(tensrec_info_group2), intent(out) :: coeffs
   !------#[ Diagram 5:
      call reconstruct4(numerator_d5, coeffs%coeffs_5)
   !------#] Diagram 5:
   !------#[ Diagram 6:
      call reconstruct4(numerator_d6, coeffs%coeffs_6)
   !------#] Diagram 6:
   !------#[ Diagram 7:
      call reconstruct4(numerator_d7, coeffs%coeffs_7)
   !------#] Diagram 7:
   !------#[ Diagram 8:
      call reconstruct4(numerator_d8, coeffs%coeffs_8)
   !------#] Diagram 8:
   !------#[ Diagram 17:
      call reconstruct3(numerator_d17, coeffs%coeffs_17)
   !------#] Diagram 17:
   !------#[ Diagram 18:
      call reconstruct3(numerator_d18, coeffs%coeffs_18)
   !------#] Diagram 18:
   !------#[ Diagram 19:
      call reconstruct3(numerator_d19, coeffs%coeffs_19)
   !------#] Diagram 19:
   !------#[ Diagram 20:
      call reconstruct3(numerator_d20, coeffs%coeffs_20)
   !------#] Diagram 20:
   !------#[ Diagram 21:
      call reconstruct3(numerator_d21, coeffs%coeffs_21)
   !------#] Diagram 21:
   !------#[ Diagram 22:
      call reconstruct3(numerator_d22, coeffs%coeffs_22)
   !------#] Diagram 22:
   !------#[ Diagram 23:
      call reconstruct3(numerator_d23, coeffs%coeffs_23)
   !------#] Diagram 23:
   !------#[ Diagram 24:
      call reconstruct3(numerator_d24, coeffs%coeffs_24)
   !------#] Diagram 24:
   !------#[ Diagram 25:
      call reconstruct3(numerator_d25, coeffs%coeffs_25)
   !------#] Diagram 25:
   !------#[ Diagram 26:
      call reconstruct3(numerator_d26, coeffs%coeffs_26)
   !------#] Diagram 26:
   !------#[ Diagram 27:
      call reconstruct3(numerator_d27, coeffs%coeffs_27)
   !------#] Diagram 27:
   !------#[ Diagram 28:
      call reconstruct3(numerator_d28, coeffs%coeffs_28)
   !------#] Diagram 28:
   !------#[ Diagram 29:
      call reconstruct3(numerator_d29, coeffs%coeffs_29)
   !------#] Diagram 29:
   !------#[ Diagram 30:
      call reconstruct3(numerator_d30, coeffs%coeffs_30)
   !------#] Diagram 30:
   !------#[ Diagram 31:
      call reconstruct3(numerator_d31, coeffs%coeffs_31)
   !------#] Diagram 31:
   !------#[ Diagram 32:
      call reconstruct3(numerator_d32, coeffs%coeffs_32)
   !------#] Diagram 32:
end subroutine reconstruct_group2
!---#] subroutine reconstruct_group2:
end module P5B_uux_ddx_golem95h3
